SeedRnd MilliSecs()

Global screenx:Float = 400
Global screeny:Float = 400
Global split20x:Float = screenx / 5.0
Global split20y:Float = screeny / 5.0
Global pointx:Float = screenx / 2.0
Global pointy:Float = screeny / 2.0

SetGraphicsDriver GLMax2DDriver()

AppTitle = "Geminator"
Global fenster:TGraphics = Graphics(screenx, screeny,,, GRAPHICS_BACKBUFFER | GRAPHICS_ALPHABUFFER | GRAPHICS_ACCUMBUFFER)

SetBlend(ALPHABLEND)

Global GAME_STATE:Int

Global img_0:TImage = LoadImage("0.png")
Global img_1:TImage = LoadImage("1.png")
Global img_2:TImage = LoadImage("2.png")
Global img_3:TImage = LoadImage("3.png")
Global img_4:TImage = LoadImage("4.png")
Global img_5:TImage = LoadImage("5.png")

Global img_back:TImage = LoadImage("back.png")

Global img_leicht:TImage = LoadImage("button-leicht.png")
Global img_mittel:TImage = LoadImage("button-mittel.png")
Global img_schwer:TImage = LoadImage("button-schwer.png")

Global img_bhelp:TImage = LoadImage("button-help.png")

Global img_end:TImage = LoadImage("end.png")

Global img_help:TImage = LoadImage("help.png")

Global img_bum:TImage = LoadImage("bum.png")
img_bum.handle_x = 50
img_bum.handle_y = 50


Type Tstone
	Global level:Int = 5
	Field x:Int, y:Int, color:Int, broken:Int
	Field img:TImage
	
	Field animx:Int, animy:Int
	Global ani:Int
	
	Function Create:Tstone(x:Int, y:Int)
		Local nstone:Tstone = New Tstone
		
		nstone.x = x
		nstone.y = y
		nstone.animx = x * 50
		nstone.animy = -50 - Tview.y
		nstone.color = Rand(0, level)
		
		Select nstone.color
			Case 0
				nstone.img = img_0
			Case 1
				nstone.img = img_1
			Case 2
				nstone.img = img_2
			Case 3
				nstone.img = img_3
			Case 4
				nstone.img = img_4
			Case 5
				nstone.img = img_5
			End Select
		
		Return nstone
	End Function
	
	Function copy:Tstone(stone:Tstone)
		Local nstone:Tstone = New Tstone
		
		nstone.x = stone.x
		nstone.y = stone.y
		nstone.color = stone.color
		nstone.img = stone.img
		
		Return nstone
	End Function
	
	
End Type

Type Tbum
	Global list:TList = CreateList()
	Field x:Float, y:Float, r:Float = Rnd(0, 45), scale:Float, color:Int
	
	Function Create(nx:Float, ny:Float, ncolor:Int)
		Local nbum:Tbum = New Tbum
		list.Addfirst(nbum)
		
		nbum.x = nx
		nbum.y = ny
		nbum.color = ncolor
	End Function
	
	Function draw()
		SetBlend(LIGHTBLEND)
		For Local dbum:Tbum = EachIn list
			Select dbum.color
				Case 0
					SetColor(255, 100, 100)
				Case 1
					SetColor(100, 100, 255)
				Case 2
					SetColor(100, 255, 100)
				Case 3
					SetColor(255, 255, 0)
				Case 4
					SetColor(0, 255, 255)
				Case 5
					SetColor(255, 0, 255)
			End Select
			dbum.r:+25
			dbum.scale:+0.05
			'SetRotation(dbum.r)
			SetScale(dbum.scale, dbum.scale)
			DrawImage(img_bum, dbum.x, dbum.y)
			If dbum.scale > 1 Then list.Remove(dbum)
		Next
		SetBlend(ALPHABLEND)
		reset_draw()
	End Function
	
	Function reset()
		list.Clear()
	End Function
End Type



Global gamefield:Tstone[6, 6]
Global firsthit:Tstone
Global secondhit:Tstone

Global checkmove:Int
Global debughalt:Int

Global score:Int

Global mh1:Int

Type Tview
	Global x:Int = 200 - 150, y:Int = 200 - 150
End Type

Global msc:Int
Global lasttime:Int = MilliSecs()
Global time:Int = MilliSecs()
'HideMouse()
While Not AppTerminate()
	lasttime = time
	time = MilliSecs()
	msc = time - lasttime
	If msc > 500 Then msc = 500
	
	Cls
	
	reset_draw()
	DrawImage(img_back, 0, 0)
	
	DrawImage(img_bhelp, 360, 370)
	
	
	
	mh1 = MouseHit(1)
	
	Select GAME_STATE
		Case 0 'menu
		
			DrawImage(img_leicht, 100, 50)
			If ismouseover(100, 50, 200, 100) And mh1 Then
				Tstone.level = 3
				GAME_STATE = 1
			End If
			
			DrawImage(img_mittel, 100, 150)
			If ismouseover(100, 150, 200, 100) And mh1 Then
				Tstone.level = 4
				GAME_STATE = 1
			End If
			
			DrawImage(img_schwer, 100, 250)
			If ismouseover(100, 250, 200, 100) And mh1 Then
				Tstone.level = 5
				GAME_STATE = 1
			End If
		
		Case 1 'build level
			Tbum.reset()
			For Local y:Int = 0 To 5
				For Local x:Int = 0 To 5
					gamefield[x, y] = Null
				Next
			Next
			
			firsthit = Null
			secondhit = Null
			score = 0
			checkmove = 0
			
			GAME_STATE = 2
		Case 2 'game
			
			Tstone.ani = 0
			For Local y:Int = 0 To 5
				For Local x:Int = 0 To 5
					If gamefield[x, y] Then
						
						If x * 50 < gamefield[x, y].animx Then gamefield[x, y].animx:-5 ; Tstone.ani = 1
						If x * 50 > gamefield[x, y].animx Then gamefield[x, y].animx:+5 ; Tstone.ani = 1
						If y * 50 < gamefield[x, y].animy Then gamefield[x, y].animy:-5 ; Tstone.ani = 1
						If y * 50 > gamefield[x, y].animy Then gamefield[x, y].animy:+5 ; Tstone.ani = 1
						
					EndIf
				Next
			Next
			
			If Tstone.ani = 0 Then
			
				If checkmove Then
					checkmove = 0
					If workgamefield(gamefield) = 0 Then
						gamefield[firsthit.x, firsthit.y] = secondhit
						gamefield[secondhit.x, secondhit.y] = firsthit
										
						Local temp2x:Int = firsthit.x
						Local temp2y:Int = firsthit.y
						firsthit.x = secondhit.x
						firsthit.y = secondhit.y
						secondhit.x = temp2x
						secondhit.y = temp2y
					EndIf
									
					firsthit = Null
					secondhit = Null
				Else
				
				
				
					If mh1 Then
						If firsthit Then
							Local posx:Float = MouseX() - Tview.x
							Local posy:Float = MouseY() - Tview.y
							
							If posx > 0 And posx < 300 And posy > 0 And posy < 300 Then
								Local tilex:Int = posx / 50
								Local tiley:Int = posy / 50
								secondhit = gamefield[tilex, tiley]
							End If
							
							If secondhit Then
								If firsthit <> secondhit Then
									
									Local go:Int
									
									If firsthit.x + 1 = secondhit.x And firsthit.y = secondhit.y Then go:+1
									If firsthit.x - 1 = secondhit.x And firsthit.y = secondhit.y Then go:+1
									If firsthit.y + 1 = secondhit.y And firsthit.x = secondhit.x Then go:+1
									If firsthit.y - 1 = secondhit.y And firsthit.x = secondhit.x Then go:+1
									
									If go = 1 Then
										gamefield[firsthit.x, firsthit.y] = secondhit
										gamefield[secondhit.x, secondhit.y] = firsthit
										
										Local tempx:Int = firsthit.x
										Local tempy:Int = firsthit.y
										firsthit.x = secondhit.x
										firsthit.y = secondhit.y
										secondhit.x = tempx
										secondhit.y = tempy
										
										checkmove = 1
										
									Else
										firsthit = Null
										secondhit = Null
									End If
								Else
									firsthit = Null
									secondhit = Null
								End If
							End If
							
						Else
							Local posx:Float = MouseX() - Tview.x
							Local posy:Float = MouseY() - Tview.y
							
							If posx > 0 And posx < 300 And posy > 0 And posy < 300 Then
								Local tilex:Int = posx / 50
								Local tiley:Int = posy / 50
								firsthit = gamefield[tilex, tiley]
							End If
							
						End If
					End If
					
					If clearbroken() Then
						If checkmoves() Then GAME_STATE = 3
						If workgamefield(gamefield) Then debughalt = True
						
					EndIf
				End If
			EndIf
			
			For Local y:Int = 0 To 5
				For Local x:Int = 0 To 5
					If gamefield[x, y] Then
						reset_draw()
						If firsthit = gamefield[x, y] Then
							DrawRect((x * 50) + Tview.x, (y * 50) + Tview.y, 50, 50)
						End If
					
						'SetBlend(LIGHTBLEND)
						DrawImage(gamefield[x, y].img, gamefield[x, y].animx + Tview.x, gamefield[x, y].animy + Tview.y)
						'SetBlend(ALPHABLEND)
						
						If gamefield[x, y].broken Then
							'SetColor(0, 0, 0)
							'DrawRect((x * 50) + Tview.x + 20, (y * 50) + Tview.y + 20, 10, 10)
							Tbum.Create((x * 50) + Tview.x + 25, (y * 50) + Tview.y + 25, gamefield[x, y].color)
						EndIf
						
					EndIf
				Next
			Next
			
			Tbum.draw()
			
			'If debughalt Then Flip(1) ; WaitKey() ; debughalt = False
			
			reset_draw()
			DrawText("Score: " + score, 200 - (TextWidth("Score: " + score) / 2.0), 385)
		Case 3 'resetgame
			
			
			reset_draw()
			DrawImage(img_end, 100, 150)
			
			DrawText("Score: " + score, 200 - (TextWidth("Score: " + score) / 2.0), 250)
			If mh1 Then GAME_STATE = 0
	End Select
	
	If ismouseover(360, 370, 50, 50) Then
		DrawImage(img_help, 0, 0)
	End If
	
	Flip(1)
Wend

End

Function checkmoves:Int()
	Local tempgf:Tstone[6, 6]
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			tempgf[x, y] = Tstone.copy(gamefield[x, y])
		Next
	Next
	
	If workgamefield(tempgf) Then Return False
	
	
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			If x > 0 Then
				Local temp:Tstone = tempgf[x, y]
				tempgf[x, y] = tempgf[x - 1, y]
				tempgf[x - 1, y] = temp
				If workgamefield(tempgf) Then Return False
				temp = tempgf[x, y]
				tempgf[x, y] = tempgf[x - 1, y]
				tempgf[x - 1, y] = temp
			EndIf
			If x < 5 Then
				Local temp:Tstone = tempgf[x, y]
				tempgf[x, y] = tempgf[x + 1, y]
				tempgf[x + 1, y] = temp
				If workgamefield(tempgf) Then Return False
				temp = tempgf[x, y]
				tempgf[x, y] = tempgf[x + 1, y]
				tempgf[x + 1, y] = temp
			EndIf
			
			If y > 0 Then
				Local temp:Tstone = tempgf[x, y]
				tempgf[x, y] = tempgf[x, y - 1]
				tempgf[x, y - 1] = temp
				If workgamefield(tempgf) Then Return False
				temp = tempgf[x, y]
				tempgf[x, y] = tempgf[x, y - 1]
				tempgf[x, y - 1] = temp
			EndIf
			If y < 5 Then
				Local temp:Tstone = tempgf[x, y]
				tempgf[x, y] = tempgf[x, y + 1]
				tempgf[x, y + 1] = temp
				If workgamefield(tempgf) Then Return False
				temp = tempgf[x, y]
				tempgf[x, y] = tempgf[x, y + 1]
				tempgf[x, y + 1] = temp
			EndIf
		Next
	Next
	
	Return True
End Function

Function clearbroken:Int()
	Local ret:Int = True
	Local scr:Int
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			If gamefield[x, y] And gamefield[x, y].broken Then
				gamefield[x, y] = Null
				scr:+50
				scr = scr * 1.25
			EndIf
		Next
	Next
	score:+scr
	
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			If gamefield[x, y] = Null Then
				ret = False
			End If
		Next
	Next
	
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			If gamefield[x, y] = Null Then
				If y > 0 And gamefield[x, y - 1] Then
					gamefield[x, y] = gamefield[x, y - 1]
					gamefield[x, y - 1] = Null
					gamefield[x, y].x = x
					gamefield[x, y].y = y
				End If
			EndIf
		Next
	Next
	
	For Local x:Int = 0 To 5
		If gamefield[x, 0] = Null Then
			gamefield[x, 0] = Tstone.Create(x, 0)
		End If
	Next
	
	
	Return ret
End Function

Function workgamefield:Int(gf:Tstone[,])
	Local ret:Int = 0
	For Local y:Int = 0 To 5
		For Local x:Int = 0 To 5
			If gf[x, y] Then
				If testrow(gf, x, y, gf[x, y].color, 1, 1, 0) Then ret = 1
				If testrow(gf, x, y, gf[x, y].color, 1, 0, 1) Then ret = 1
				
				If testrow(gf, x, y, gf[x, y].color, 1, -1, 0) Then ret = 1
				If testrow(gf, x, y, gf[x, y].color, 1, 0, -1) Then ret = 1
			EndIf
		Next
	Next
	Return ret
End Function

Function testrow:Int(gf:Tstone[,], x:Int, y:Int, color:Int, deeph:Int, movex:Int, movey:Int)
	If x + movex >= 0 And x + movex < 6 And y + movey >= 0 And y + movey < 6 And color = gf[x + movex, y + movey].color Then
		
			If testrow(gf, x + movex, y + movey, color, deeph - 1, movex, movey) Then
				gf[x, y].broken = True
				
				
				Return True
			Else
				If deeph < 1 Then
					gf[x, y].broken = True
					
					
					Return True
				EndIf
			End If
		
	End If
	Return False
End Function

Function reset_draw()
	SetRotation(0)
	SetColor(255, 255, 255)
	SetHandle(0.0, 0.0)
	SetAlpha(1.0)
	SetScale(1.0, 1.0)
	SetOrigin(0.0, 0.0)
End Function

Function calc_move:Float(speed:Float)
	If speed <> 0 Then Return ((speed * Float(msc) / 100.0)) Else Return 0
End Function

Function calc_keymove:Float(entferung:Float, timing:Float)
	If entferung <> 0 And timing > 0 Then Return ((entferung / timing) * Float(msc)) Else Return 0
End Function

Function ismouseover:Byte(x:Int, y:Int, l:Int, w:Int)
	If x < MouseX() And x + l > MouseX() And y < MouseY() And y + w > MouseY() Then Return 1 Else Return 0
End Function


